// Tide Protocol - Infrastructure for the Personal Data economy
// Copyright (C) 2019 Tide Foundation Ltd
// 
// This program is free software and is subject to the terms of 
// the Tide Community Open Source License as published by the 
// Tide Foundation Limited. You may modify it and redistribute 
// it in accordance with and subject to the terms of that License.
// This program is distributed WITHOUT WARRANTY of any kind, 
// including without any implied warranty of MERCHANTABILITY or 
// FITNESS FOR A PARTICULAR PURPOSE.
// See the Tide Community Open Source License for more details.
// You should have received a copy of the Tide Community Open 
// Source License along with this program.
// If not, see https://tide.org/licenses_tcosl-1-0-en

import C25519Key from './src/c25519Key';
import AESKey from './src/aesKey';

test2();

function test2() {
    
    var keyMsg = "AxKhwUF3sBo3NXx9O4aPPmKLhfDeCcWXM0ihY33ZkgZcEcAzjTTcF2RRxBOAUTkDswzBVN0i/c5kGLVYzv1jOjDRKehtQfIn1HE5bV4vjhPEUdsEG8pUunlMQxPCqvui";
    var messageMsg = "AhBD0/UBCR6FijR5XPbr95LBIFHowjk4fqz0XYK/PYkX7l+4u7wleFhOleuYW0TpIYKW";
    var signatureMsg = "A6rEAkjXWzhrZYxIc1NhPR1UYYQQEKzaYZYx0fJ+5GcPgvSu+dJdOAOOMYE9rK2bDzskmkSgWt26aPoJU3/A5A==";
    

    var key = C25519Key.from(keyMsg);
    var message = Buffer.from(messageMsg, 'utf-8');
    var signature = Buffer.from(signatureMsg, 'base64');

    var sw = key.public().verify(message, signature);

    console.log(sw);
    //console.log(message.toString('hex'))
    //console.log(signature.toString('hex'));
}

function test() {
    var key = C25519Key.generate();
    var message = new AESKey().toString();
    var signature = key.sign(message);
    
    var isValid = key.public().verify(message, signature);
    
    console.log(`keyMsg: ${key}`);
    console.log(`messageMsg: ${message}`);
    console.log(`signatureMsg: ${signature.toString('base64')}`);
    console.log(`isValid: ${isValid}`);
}
