import BigInt from 'big-integer';
import BN from 'bn.js';
import C25519Key from '../src/c25519Key';
import AesSherableKey from '../src/aesSherableKey';
import C25519Cipher from '../src/c25519Cipher';

import { getBN } from '../src/bnInput';
import C25519Point from '../src/c25519Point';


run();

function run() {
    console.log(C25519Point.n.toArray(256));
}



function test() {
    try {
        var aaa = getBN(BigInt.one);
        console.log(aaa);
        console.log(getBN(null));


        var cvk = C25519Key.from('BveaUy87k/A5unMZG6ls+dUNGzSxQIoZozsu1MFO6c95V9/7C1sFtNADl43FkAW92WajkIbQzJL9SACrmGmthxZzj0dRdd2B1orjSjceuj3UbB3zYglgypG2YweyNzJ7');
        var strIds = "22113505911718994525781639306512195192|321537977803339698268417283468003415206|72579493773760286208972967319742096539";
        var strPartials = ['eIeWp/gyclKFweJdgUaM0Rkgb9vc6MeCznNGo4xu2jswpUYiOgVWlv7XYlLC4n1OPKpyOon3KuEvApqXLNqhRFtFGNd9dr9zgvxAwVhMX7Nv5FUxE3VVydxIhS2qr1SM',
            'eIeWp/gyclKFweJdgUaM0Rkgb9vc6MeCznNGo4xu2jsLV0kWUEdxQksUYOXKtl+DFMtDbta3WyW6GZHVm8U1y3BY5HrTuOBAfFUR5XDIfj7AWp2BzqVWJ/fJU9xcfQyi',
            'eIeWp/gyclKFweJdgUaM0Rkgb9vc6MeCznNGo4xu2jsU0MtGwCZbTyljdEwATo6VYCkM8EROmK/ngWxocjkccgNXNLgwaPkqstEGOzLpI25ESTGk7zK4AqG8hipydlay'];
    
        var ids = strIds.split('|').map(str => BigInt(str));
        var partials = strPartials.map(prt => C25519Cipher.fromString(prt));
    
        var plain = C25519Cipher.decryptShares(partials, ids);
        
        var cvkTag = AesSherableKey.from(plain);
        console.log(cvk.toString());
        console.log(cvkTag.toString());
        console.log(plain.length);
        
    } catch (error) {
        console.log(error);
    }
}

function main() {
    var threshold = 2;
    var ids = [1, 2, 3];

    var key = C25519Key.generate();
    var shares = key.share(threshold, ids, true);
    var m = new AesSherableKey();

    var cipher = key.encryptKey(m);
    var cipherShared = shares.map(shr => shr.partialDecrypt(cipher.toArray()));
    var plain = C25519Cipher.decryptShares(cipherShared, ids);
    var mTag = AesSherableKey.from(plain);

    console.log(m.toString() === mTag.toString());
    console.log(m.toString());
    console.log(mTag.toString());
}

                                   